每日一练:贪心-递增的三元子序列

334. 递增的三元子序列 - 力扣(LeetCode)

题目要求:

给你一个整数数组 nums ,判断这个数组中是否存在长度为 3 的递增子序列。

如果存在这样的三元组下标 (i, j, k) 且满足 i < j < k ,使得 nums[i] < nums[j] < nums[k] ,返回 true ;否则,返回 false 。

示例 1:

复制代码
输入:nums = [1,2,3,4,5]
输出:true
解释:任何 i < j < k 的三元组都满足题意

示例 2:

复制代码
输入:nums = [5,4,3,2,1]
输出:false
解释:不存在满足题意的三元组

示例 3:

复制代码
输入:nums = [2,1,5,0,4,6]
输出:true
解释:三元组 (3, 4, 5) 满足题意,因为 nums[3] == 0 < nums[4] == 4 < nums[5] == 6

提示:

  • 1 <= nums.length <= 5 * 105
  • -231 <= nums[i] <= 231 - 1

贪心算法 O(N):

这道题是每日一练:贪心-最长递增子序列-CSDN博客的简单版,因为只需要找到长度为3的递增子序列即可。

cpp 复制代码
class Solution {
public:
    bool increasingTriplet(vector<int>& nums) {
        int n = nums.size();

        vector<int> find = {nums[0]};

        for (int i = 1; i < n; i++) {
            if (find.back() < nums[i])
                find.push_back(nums[i]);
            else {
                for (int j = 0; j < find.size(); j++) {
                    if(find[j]>=nums[i])
                    {
                        find[j]=nums[i];
                        break;
                    }
                }
            }

            if (find.size() >= 3)
                return true;
        }

        return false;
    }
};
相关推荐
揽星河..5 小时前
【C语言】分支和循环
c语言·c++·算法
Fuyo_11197 小时前
C++ AVL树保姆级详解:从平衡因子到四大旋转机制
java·c++·算法
傲世仙尊8 小时前
继承-类设计层次复用切片转换与菱形继承的死结
c++
架构师伯子明8 小时前
FFmpeg C++学习(一):编译和demo
开发语言·c++·学习
纪念 2298 小时前
C++算法(六)
开发语言·c++·算法
ShineWinsu9 小时前
对于Qt:QCheckBox常见属性的详细解析
c++·qt·面试·笔试·gui·qcheckbox·多选框
AI的探索之旅9 小时前
97 个 OpenCV 实例(三十七):二维码识别,一张图四个码的陷阱
c++·opencv·计算机视觉
UIU11410 小时前
P16237 [蓝桥杯 2026 省 B] 应急布线
数据结构·c++·算法·蓝桥杯
raindayinrain10 小时前
c++设计模式
开发语言·c++·设计模式
旖旎夜光10 小时前
LeetCode 315: 算右侧小于当前元素的个数(归并排序) —— 题解
c++·学习·算法·leetcode·排序算法